--
--  AutoBar
--  Copyright 2004, 2005, 2006 original author. 
--  Copyright is expressly not transferred to Blizzard.
-- 
--  Configurable set of 24 buttons that seeks out configured items
--  in your pack for use. Intended primarily for consumables. Not 
--  for use with spells, skills, trinkets, or powers.
--
--  Maintained by Azethoth / Toadkiller of Proudmoore.  Original author Saien of Hyjal
--  http://www.curse-gaming.com/en/wow/addons-4430-1-autobar-toadkiller.html
--

-- Coming Attractions
-- Dont show buff items if buff in place
-- Remove custom item insertion.  Not needed if u can drag & drop.
-- On click bring config to front.
-- Reverse order option for a slot?
-- Defaulting, Named Custom Categories, Named Custom Slots, Named button ranges.  Layered defaults.  Class & general defaults.
-- Set operations / calculated categories. 
-- Lock all bars option for drag handle
-- Disabled code that hid character buttons when docking to main menu.  These have unintended side effects.

-- 1.12.03
-- Korean thanks to Sayclub

-- 1.12.02.05
-- Chinese Simplified & Traditional (Thanks PDI175)
-- Fixed some typos in localization.

-- 1.12.02.04
-- Pet feed on right click should now work.  Tx Kerrang.  Still need to upgrade the pet food category handling itself.

-- 1.12.02.03
-- Fixed onload issue that broke slash commands
-- Autobar now dismisses with the escape key as it should
-- Added click for config show / hide

-- 1.12.02.02
-- New 1.12 function ClearCursor() called after drag & drop.
-- Juju
-- First cut of tabbed interface for config
-- 24 buttons
-- Arathi Basin Field Ration
-- Config dialog is now draggable
-- Hunter Pet Food & Feeding
-- First cut at blizzard style dialog.  A frustrating thing as texcoords don't act as expected.

-- 1.12.02
-- Dock to is now list based with a drop down.  I will make the drop down pretty some other time.  Needs settings for various bars.
-- Empty Slot button added.
-- Popup Z order increased so its in front of other mods

-- 1.12.01
-- Chinese Simplified & Traditional (Thanks PDI175)
-- TOC updated.
-- Fixed plain buttons bug
-- Improved config layout for Korean.

-- 1.11.16.01
-- Fixed popup click bug.  Apparently mouseup events do not allow casting like click events.  Strange.
-- Disabled some config checboxes for single category slots.  Fixes crash.
-- Fixed keybinding screwup.
-- Some more hunter pet foods added.  meats aren't done yet.
-- Added a drag handle for the bar.  Left click to lock right click to bring up options.  Handle can be hidden.
-- Slot specific option to disable popup.
-- Slot specific option to rearrange category priority on use.
-- Increased max popup buttons to 12.

-- 1.11.15.04
-- Done button on config panel to avoid confusion.
-- Option to show Category Icon for slots with 0 item count.  Displayed dark & with -- to distinguish them from regular slots.
-- Scale item count, hotKey and Cooldown Clock text beyond size 36 and up to size 72
-- First cut at a popup list for slots with 2 or more available items
-- Added some unsorted items to pet foods.  These will be broken till sorted.
-- Config for popup direction
-- Fixed popup button scaling
-- Popup on modifier key
-- Popup disable
-- Tooltip for popup buttons
-- Added Jungle Remedy
-- Popup hit rect overlap fixed

-- 1.11.14.03
-- New User / deleted wtf config file bug fix.  tx Xavior for finding it.
-- Ahn Qirajh translation for Chinese. Thanks PDI175.
-- Typo fixed
-- Working Korean I think.  Thanks to Sayclub

-- 1.11.13
-- Deutch! Ser gut Teodred!

-- 1.11.12
-- Korean thanks to Sayclub!

-- 1.11.11
-- Ooh, Traditional Chinese thanks to PDI175
-- Roasted Quail added to pet meats
-- Use the highest priority item for the icon.  (ie. the bottom one in the category list).

-- 1.11.10
-- More Drag & Drop: rearrange button categories now as well
-- Drag from inventory into a button's items (or click on an item then click on category button)
-- Potions: Holy Protection, Agility, Strength, Fortitude, Intellect, Wisdom, Defense, Troll Blood 

-- 1.11.09
-- Anti-Venom
-- Global smart self cast checkbox
-- Scrolls of Agility, Intellect, Protection, Stamina, Strength, Spirit
-- Food categories for no bonus food so hunters can feed themselves

-- 1.11.08
-- Drag & Drop to rearrange slot category order in the config dialog.
-- Close button added to config
-- Updated some category icons.

-- 1.11.07
-- Row & column sliders in the config panel are now freely slideable.

-- 1.11.06
-- Fixed glitch at 6 columns

-- 1.11.05
-- Friendship Bread, Freshly Squeezed Lemonade, Wildvine Potion, Sagefish Delight, Smoked Sagefish
-- Dirge's Kickin' Chimaerok Chops, 
-- Fixed: Essence Mango,

-- 1.11.04
-- Reset to default button for the buttons
-- Hide tooltips option
-- Demonic and Dark Runes, Battle Standards, Invulnerability Potions

-- 1.11.03.01
-- Deathcharger's Reins, Qiraji Mounts
-- Reworked defaults a bit.

-- 1.11.02
-- Mojos of Zanza & essence mangos; arcane, fire, frost, nature, shadow, spell Protection Potions.
-- Dreamless sleep
-- First cut of cooldown.

-- 1.11.01
-- Added new AD oil & sharpening stone.
-- Expand up to 18 buttons.
-- Rolled in the nurfed version's changes for pvp potions
-- Chocolate Square

--  2006.03.31
--    Minor category changes
--  2006.02.10
--    Enriched Manna Biscuit/Alterac Manna Biscuit (which is usable everywhere) 
--      moved to their own category("Food & Water Combo") - Update your buttons
--    Custom items can now appear on multiple buttons, as intended.
--  2006.01.28
--    Oils fixed.
--    Custom items got broken by selfcast config. Fixed. 
--  2006.01.20
--    Will no longer fallback to zone-restricted items when all items in a button are ineligible.
--    Fixed bug where hitting keybinding for a button that has no items found will popup an error
--    Buttons will skip items too high in level for character
--  2006.01.12
--    Selfcast is back
--    AutoBar re-parented so it hides with an Alt-Z
--    Configuration checkbox to hide Keybind text 
--    Configuration checkbox to hide Count text
--    Configuration checkbox to show empty buttons
--    Keybind text and count text scales with button width.
--    Can now open configuration while dead.
--    "Num Pad" key bindings are now shortened to just N in display.
--    Removed /ab as a shortcut for the depreciated slash commands.
--    Fixed Mana potion hp restriction - should be mana restriction
--    Minimum button width/height set to 9 pixels instead of 18.
--  2006.01.06
--    Release of complete re-write.
--

AutoBar = {};

AUTOBAR_VERSION = GetAddOnMetadata("AutoBar", "Version");
------------------------------------
BINDING_HEADER_AUTOBAR_SEP = "Auto Bar";
BINDING_NAME_AUTOBAR_CONFIG = "Configuration Window";
BINDING_NAME_AUTOBAR_BUTTON1 = "Button 1";
BINDING_NAME_AUTOBAR_BUTTON2 = "Button 2";
BINDING_NAME_AUTOBAR_BUTTON3 = "Button 3";
BINDING_NAME_AUTOBAR_BUTTON4 = "Button 4";
BINDING_NAME_AUTOBAR_BUTTON5 = "Button 5";
BINDING_NAME_AUTOBAR_BUTTON6 = "Button 6";
BINDING_NAME_AUTOBAR_BUTTON7 = "Button 7";
BINDING_NAME_AUTOBAR_BUTTON8 = "Button 8";
BINDING_NAME_AUTOBAR_BUTTON9 = "Button 9";
BINDING_NAME_AUTOBAR_BUTTON10 = "Button 10";
BINDING_NAME_AUTOBAR_BUTTON11 = "Button 11";
BINDING_NAME_AUTOBAR_BUTTON12 = "Button 12";
BINDING_NAME_AUTOBAR_BUTTON13 = "Button 13";
BINDING_NAME_AUTOBAR_BUTTON14 = "Button 14";
BINDING_NAME_AUTOBAR_BUTTON15 = "Button 15";
BINDING_NAME_AUTOBAR_BUTTON16 = "Button 16";
BINDING_NAME_AUTOBAR_BUTTON17 = "Button 17";
BINDING_NAME_AUTOBAR_BUTTON18 = "Button 18";
BINDING_NAME_AUTOBAR_BUTTON19 = "Button 19";
BINDING_NAME_AUTOBAR_BUTTON20 = "Button 20";
BINDING_NAME_AUTOBAR_BUTTON21 = "Button 21";
BINDING_NAME_AUTOBAR_BUTTON22 = "Button 22";
BINDING_NAME_AUTOBAR_BUTTON23 = "Button 23";
BINDING_NAME_AUTOBAR_BUTTON24 = "Button 24";
------------------------------------
AUTOBAR_MAXBUTTONS = 24;
AUTOBAR_MAXPOPUPBUTTONS = 12;
AUTOBAR_MAXSLOTCATEGORIES = 8;
-----------------------------------
AutoBar_Debug = nil;
AutoBar_Player = nil; -- global
--
local AutoBar_ConfigLoaded = nil;
AutoBar_SearchedForItems = {};
local AutoBar_ButtonItemList = {};
local AutoBar_ButtonItemList_Reversed = {};
local AutoBar_Buttons_CurrentItems = {};
--
local AutoBar_InWorld = nil;
local AutoBar_InCombat = nil; -- For item use restrictions
local Autobar_InBG = nil; -- For battleground only items
------------------------------------


AutoBarConfigSliders =
{
	rows =
	{
		["name"] = "AutoBarConfigFrameBarRows",
		["text"] = AUTOBAR_CONFIG_ROW.." - ",
		["default"] = 1,
	},
	columns = 
	{
		["name"] = "AutoBarConfigFrameBarColumns",
		["text"] = AUTOBAR_CONFIG_COLUMN.." - ",
		["default"] = AUTOBAR_MAXBUTTONS,
	},
	gapping = 
	{
		["name"] = "AutoBarConfigFrameBarGapping",
		["text"] = AUTOBAR_CONFIG_GAPPING.." - ",
		["default"] = 3,
	},
	alpha =   
	{
		["name"] = "AutoBarConfigFrameButtonsAlpha",
		["text"] = AUTOBAR_CONFIG_ALPHA.." - ",
		["default"] = 10,
	},
	buttonWidth =
	{
		["name"] = "AutoBarConfigFrameButtonsButtonWidth",
		["text"] = AUTOBAR_CONFIG_BUTTONWIDTH.." - ",
		["default"] = 36,
	},
	buttonHeight =
	{
		["name"] = "AutoBarConfigFrameButtonsButtonHeight",
		["text"] = AUTOBAR_CONFIG_BUTTONHEIGHT.." - ",
		["default"] = 36,
	},
	dockShiftX =
	{
		["name"] = "AutoBarConfigFrameBarDockShiftX",
		["text"] = AUTOBAR_CONFIG_DOCKSHIFTX.." - ",
		["default"] = 0,
	},
	dockShiftY =
	{
		["name"] = "AutoBarConfigFrameBarDockShiftY",
		["text"] = AUTOBAR_CONFIG_DOCKSHIFTY.." - ",
		["default"] = 0,
	},
}


function AutoBar.LinkDecode(link)
	if (link) then
		local _, _, id, name = string.find(link,"|Hitem:(%d+):%d+:%d+:%d+|h%[([^]]+)%]|h|r$");
		if (id and name) then
			return name, tonumber(id);
		end
	end
end


-- Reset the buttons to default
function AutoBar.ButtonsReset()
	AutoBar_Config[AutoBar_Player].buttons = nil;
	AutoBar.ConfigInit();
end


-- Set up defaults for the player if required
function AutoBar.ConfigInit()
	if (not AutoBar_Config) then AutoBar_Config = {}; end
	if (not AutoBar_Config[AutoBar_Player]) then
		AutoBar_Config[AutoBar_Player] = {};
	end
	---
	if (AutoBar_Config[AutoBar_Player].scaling) then
		-- Config is from pre re-write. Not upgrading.
 		AutoBar_Config[AutoBar_Player] = {};
		AutoBar_Msg(AUTOBAR_CHAT_MESSAGE1);
	end
	---
	
	---
	if (not AutoBar_Config[AutoBar_Player].buttons) then
		local _, class = UnitClass("player");
		AutoBar_Config[AutoBar_Player].autoSmartSelfCast = true;
		AutoBar_Config[AutoBar_Player].buttons = {};
		AutoBar_Config[AutoBar_Player].buttons[1] = { "BANDAGES", "ALTERAC_BANDAGES", "WARSONG_BANDAGES", "ARATHI_BANDAGES", "UNGORO_RESTORE" };
		AutoBar_Config[AutoBar_Player].buttons[2] = { "HEALPOTIONS", "REJUVENATION_POTIONS", "WHIPPER_ROOT", "NIGHT_DRAGONS_BREATH", "PVP_HEALPOTIONS", "ALTERAC_HEAL", "HEALTHSTONE" };
		AutoBar_Config[AutoBar_Player].buttons[4] = { "PROTECTION_ARCANE", "PROTECTION_FROST", "PROTECTION_NATURE", "PROTECTION_SHADOW", "PROTECTION_FIRE", "PROTECTION_SPELLS" };
		AutoBar_Config[AutoBar_Player].buttons[7] = { "FOOD", "FOOD_STAMINA", "FOOD_CONJURED" };
		AutoBar_Config[AutoBar_Player].buttons[8] = { "FOOD_WATER", "FOOD_ARATHI", "FOOD_WARSONG" };
		AutoBar_Config[AutoBar_Player].buttons[9] = "EXPLOSIVES";
		AutoBar_Config[AutoBar_Player].buttons[10] = "FISHINGITEMS";
		AutoBar_Config[AutoBar_Player].buttons[11] = "SHARPENINGSTONES";
		AutoBar_Config[AutoBar_Player].buttons[12] = "WEIGHTSTONE";
		AutoBar_Config[AutoBar_Player].buttons[13] = "SWIFTNESSPOTIONS";
		AutoBar_Config[AutoBar_Player].buttons[14] = "ACTION_POTIONS";
		if (class == "WARRIOR") then
			AutoBar_Config[AutoBar_Player].buttons[3] = "RAGEPOTIONS";
		elseif (class == "ROGUE") then
			AutoBar_Config[AutoBar_Player].buttons[3] = "ENERGYPOTIONS";
			AutoBar_Config[AutoBar_Player].buttons[11] = "POISON-MINDNUMBING";
			AutoBar_Config[AutoBar_Player].buttons[12] = "POISON-WOUND";
			AutoBar_Config[AutoBar_Player].buttons[13] = "POISON-CRIPPLING";
			AutoBar_Config[AutoBar_Player].buttons[14] = "POISON-DEADLY";
			AutoBar_Config[AutoBar_Player].buttons[15] = "POISON-INSTANT";
		elseif (class == "MAGE") then
			AutoBar_Config[AutoBar_Player].buttons[3] = { "MANAPOTIONS", "REJUVENATION_POTIONS", "NIGHT_DRAGONS_BREATH", "PVP_MANAPOTIONS", "ALTERAC_MANA", "MANASTONE" };
		else
			AutoBar_Config[AutoBar_Player].buttons[3] = { "MANAPOTIONS", "REJUVENATION_POTIONS", "NIGHT_DRAGONS_BREATH", "PVP_MANAPOTIONS", "ALTERAC_MANA"  };
		end
		if (class ~= "ROGUE" and class ~= "WARRIOR") then
			AutoBar_Config[AutoBar_Player].buttons[5] = { "WATER", "WATER_CONJURED" };
			AutoBar_Config[AutoBar_Player].buttons[6] = "WATER_SPIRIT";
		end

		-- Buff Slot
		AutoBar_Config[AutoBar_Player].buttons[AUTOBAR_MAXBUTTONS - 2] = { "SCROLL_AGILITY", "SCROLL_INTELLECT", "SCROLL_PROTECTION", "SCROLL_SPIRIT", "SCROLL_STAMINA", "SCROLL_STRENGTH", "BUFF_ATTACKPOWER", "BUFF_ATTACKSPEED" };
		 --, "BUFF_DODGE", "BUFF_FROST", "BUFF_FIRE"

		-- Mount Slot
		local _, raceEnglish = UnitRace("player");
		if (raceEnglish == "Troll") then
			AutoBar_Config[AutoBar_Player].buttons[AUTOBAR_MAXBUTTONS - 1] = { "MOUNTS_TROLL", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "Orc") then
			AutoBar_Config[AutoBar_Player].buttons[AUTOBAR_MAXBUTTONS - 1] = { "MOUNTS_ORC", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "Scourge") then
			AutoBar_Config[AutoBar_Player].buttons[AUTOBAR_MAXBUTTONS - 1] = { "MOUNTS_UNDEAD", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "Tauren") then
			AutoBar_Config[AutoBar_Player].buttons[AUTOBAR_MAXBUTTONS - 1] = { "MOUNTS_TAUREN", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "Human") then
			AutoBar_Config[AutoBar_Player].buttons[AUTOBAR_MAXBUTTONS - 1] = { "MOUNTS_HUMAN", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "NightElf") then
			AutoBar_Config[AutoBar_Player].buttons[AUTOBAR_MAXBUTTONS - 1] = { "MOUNTS_NIGHTELF", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "Dwarf") then
			AutoBar_Config[AutoBar_Player].buttons[AUTOBAR_MAXBUTTONS - 1] = { "MOUNTS_DWARF", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		elseif (raceEnglish == "Gnome") then
			AutoBar_Config[AutoBar_Player].buttons[AUTOBAR_MAXBUTTONS - 1] = { "MOUNTS_GNOME", "MOUNTS_SPECIAL", "MOUNTS_QIRAJI" };
		end
		AutoBar_Config[AutoBar_Player].buttons[AUTOBAR_MAXBUTTONS - 1].popupDisable = true;

		AutoBar_Config[AutoBar_Player].buttons[AUTOBAR_MAXBUTTONS] = "HEARTHSTONE";
	end
	
	-- Also update display defaults if needed
	if (not AutoBar_Config[AutoBar_Player].display) then
		AutoBar_Config[AutoBar_Player].display = {};
	end
	AutoBar.ConfigUpdated();
end


local function AutoBar_BuildItemList()
	local function AddItemInfo(identifier, buttonnum)
		if (AutoBar_Category_Info[identifier] and AutoBar_Category_Info[identifier].items) then
			local index, j;
			for index, j in AutoBar_Category_Info[identifier].items do
				if (AutoBar_SearchedForItems[j]) then
					table.insert(AutoBar_SearchedForItems[j], buttonnum);
				else
					AutoBar_SearchedForItems[j] = { buttonnum, identifier, index };
				end
				table.insert(AutoBar_ButtonItemList[buttonnum], j);
			end
		else
			if (AutoBar_SearchedForItems[identifier]) then
				table.insert(AutoBar_SearchedForItems[identifier], buttonnum);
			else
				AutoBar_SearchedForItems[identifier] = { buttonnum, identifier, 0 };
			end
			table.insert(AutoBar_ButtonItemList[buttonnum], identifier);
		end
	end
	AutoBar_SearchedForItems = {};
	AutoBar_ButtonItemList_Reversed = {};
	local index;
	for index = 1, AUTOBAR_MAXBUTTONS, 1 do
		if (AutoBar_Config[AutoBar_Player].buttons[index]) then
			local i, j;
			AutoBar_ButtonItemList[index] = {};
			AutoBar_ButtonItemList_Reversed[index] = {};
			if (type(AutoBar_Config[AutoBar_Player].buttons[index]) == "table") then
				for i, j in AutoBar_Config[AutoBar_Player].buttons[index] do
					AddItemInfo (j, index);
				end
			else
				AddItemInfo (AutoBar_Config[AutoBar_Player].buttons[index], index);
			end
			for i, j in AutoBar_ButtonItemList[index] do
				AutoBar_ButtonItemList_Reversed[index][j] = i;
			end
		end
	end
end

function AutoBar_Button_GetDisplayItem(buttonnum)
	local index, bag, slot, rank, itemId, category, categoryIndex, acceptable, cooldowntime, level;
	local cooldownIndex, start, duration, enable, fallback;
	if (AutoBar_Buttons_CurrentItems[buttonnum]) then
		index = table.getn(AutoBar_Buttons_CurrentItems[buttonnum]);
	else
		index = 0;
	end
	while (index > 0 and not acceptable) do
		bag = AutoBar_Buttons_CurrentItems[buttonnum][index].items[1][1];
		slot = AutoBar_Buttons_CurrentItems[buttonnum][index].items[1][2];
		rank = AutoBar_Buttons_CurrentItems[buttonnum][index].rank;
		itemId = AutoBar_ButtonItemList[buttonnum][rank];
		if (type(itemId) == "number") then
			_,_,_,level = GetItemInfo(itemId);
		else
			level = 0;
		end
		if (AutoBar_SearchedForItems[itemId]) then 
			category = AutoBar_SearchedForItems[itemId][2];
			categoryIndex = AutoBar_SearchedForItems[itemId][3];
		else
			category = nil;
			categoryIndex = nil;
		end
		--
		start, duration, enable = GetContainerItemCooldown(bag, slot);
		if (start > 0 and duration > 0) then
			local tmp = start - GetTime() + duration;
			if (not cooldowntime or tmp < cooldowntime) then
				cooldowntime = tmp;
				cooldownIndex = index;
			end
			index = index - 1;
		elseif (level > UnitLevel("player")) then
			index = index - 1;
		elseif (AutoBar_Category_Info[category] and AutoBar_Category_Info[category].location and AutoBar_Category_Info[category].location ~= GetRealZoneText()) then
			index = index - 1;
		elseif (AutoBar_Category_Info[category] and AutoBar_Category_Info[category].battleground and not Autobar_InBG) then
			index = index - 1;
		elseif (AutoBar_Category_Info[category]) then
			if (not fallback) then 
				fallback = index; 
			end
			if (AutoBar_Category_Info[category].combatonly and not AutoBar_InCombat) then
				index = index - 1;
			elseif (AutoBar_Category_Info[category].noncombat and AutoBar_InCombat) then
				index = index - 1;
			elseif (AutoBar_Category_Info[category].limit) then
				local losthp = UnitHealthMax("player") - UnitHealth("player");
				local lostmana = UnitManaMax("player") - UnitMana("player");
				if (UnitPowerType("player") ~= 0 ) then
					--if (UnitClass("player") == "Druid") then
						-- Can't check mana in druid forms
					--	lostmana = 0;
					--else
						-- Class doesn't have mana, don't limit
						lostmana = 10000;
					--end
				end
				if (AutoBar_Category_Info[category].limit.downhp and AutoBar_Category_Info[category].limit.downhp[categoryIndex] > losthp) then
					index = index - 1
				elseif (AutoBar_Category_Info[category].limit.downmana and AutoBar_Category_Info[category].limit.downmana[categoryIndex] > lostmana) then
					index = index - 1
				else
					acceptable = true;
				end
			else
				acceptable = true;
			end
		else
			acceptable = true;
		end
	end
	if (not acceptable) then
		if (fallback) then
			index = fallback;
		elseif (cooldownIndex) then
			index = cooldownIndex;
		elseif (AutoBar_Buttons_CurrentItems[buttonnum]) then
			index = table.getn(AutoBar_Buttons_CurrentItems[buttonnum]);
		else
			index = nil;
		end
	end
	--
	if (index) then
		bag = AutoBar_Buttons_CurrentItems[buttonnum][index].items[1][1];
		slot = AutoBar_Buttons_CurrentItems[buttonnum][index].items[1][2];
		rank = AutoBar_Buttons_CurrentItems[buttonnum][index].rank;
	else
		bag = nil; slot = nil; rank = nil;
	end
	if (AutoBar_ButtonItemList[buttonnum]) then
		itemId = AutoBar_ButtonItemList[buttonnum][rank];
		if (AutoBar_SearchedForItems[itemId]) then 
			category = AutoBar_SearchedForItems[itemId][2];
			categoryIndex = AutoBar_SearchedForItems[itemId][3];
		else
			category = nil;
			categoryIndex = nil;
		end
	else
		itemId = nil; category = nil; categoryIndex = nil;
	end
	return bag, slot, rank, itemId, category, categoryIndex, index, acceptable, cooldowntime;
end


function AutoBar_Button_UpdateButtons()
	local buttonnum, i, button, icon, normalTexture, countText, bag, slot, index, items;
	local hotKey, count, itemCount, keyText, actioncommand, cooldown;
	for buttonnum = 1, AUTOBAR_MAXBUTTONS, 1 do
		button = getglobal("AutoBarFrame_Button"..buttonnum);
		icon = getglobal("AutoBarFrame_Button"..buttonnum.."Icon");
		normalTexture = getglobal("AutoBarFrame_Button"..buttonnum.."NormalTexture");
		countText = getglobal("AutoBarFrame_Button"..buttonnum.."Count");
		hotKey = getglobal("AutoBarFrame_Button"..buttonnum.."HotKey");
		cooldown = getglobal("AutoBarFrame_Button"..buttonnum.."Cooldown");
		if (not button.forcehidden and button.effectiveButton) then
			button:Show();
			bag, slot,_,_,_,_,index,enabled = AutoBar_Button_GetDisplayItem(button.effectiveButton)
			if (bag and slot) then
				local start, duration, enable = GetContainerItemCooldown(bag, slot);
				CooldownFrame_SetTimer(cooldown, start, duration, enable);
				items = AutoBar_Buttons_CurrentItems[button.effectiveButton][index].items
				count = 0;
				for i, bagSlot in items do
					_, itemCount = GetContainerItemInfo(bagSlot[1], bagSlot[2]);
					if (itemCount) then
						count = count + itemCount;
					end
				end
				icon:SetTexture(GetContainerItemInfo(bag, slot));
				if (AutoBar_Config[AutoBar_Player].display.plainButtons) then
					icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
				else
					icon:SetTexCoord(0, 1, 0, 1)
				end
				if (count > 1) then
					countText:SetText(count);
				else
					countText:SetText("");
				end

				if (enabled) then
					icon:SetVertexColor(1, 1, 1);
					normalTexture:SetVertexColor(1, 1, 1);
				elseif (start > 0 and duration > 0) then
					icon:SetVertexColor(1, 1, 1);
					normalTexture:SetVertexColor(1, 1, 1);
				else
					icon:SetVertexColor(0.4, 0.4, 0.4);
					normalTexture:SetVertexColor(1, 1, 1);
				end

				actioncommand = "AUTOBAR_BUTTON"..button.effectiveButton;
				if (actioncommand) then
					keyText = GetBindingKey(actioncommand);
					if (keyText) then
						keyText = string.gsub(keyText, "CTRL", "C");
						keyText = string.gsub(keyText, "ALT", "A");
						keyText = string.gsub(keyText, "SHIFT", "S");
						keyText = string.gsub(keyText, "NUMPAD", "N");
						hotKey:SetText(keyText);
					else
						hotKey:SetText("");
					end
				end
			else
				CooldownFrame_SetTimer(cooldown, 0, 0, 0);
				if (AutoBar_Config[AutoBar_Player].display.showCategoryIcon and AutoBar_Config[AutoBar_Player].buttons[button.effectiveButton]) then
				    -- Button is empty so show Category Icon
					local buttonInfo = AutoBar_Config[AutoBar_Player].buttons[button.effectiveButton];
					icon:SetTexture(AutoBar_GetTexture(buttonInfo));
					countText:SetText("--");
					hotKey:SetText("");
					icon:SetVertexColor(0.2, 0.2, 0.2);
					normalTexture:SetVertexColor(1, 1, 1);
				else
				    -- Button is empty
					icon:SetTexture("");
					countText:SetText("");
					hotKey:SetText("");
				end
			end
		else
			button:Hide();
		end
	end
end


local function AutoBar_AssignButtons()
	local displayButton = 0;
	local buttonIndex, buttonInfo, rankIndex, items;
	for buttonIndex = 1, AUTOBAR_MAXBUTTONS, 1 do
		if (AutoBar_Config[AutoBar_Player].display.showEmptyButtons or AutoBar_Buttons_CurrentItems[buttonIndex]) then
			displayButton = displayButton + 1;
			local button = getglobal("AutoBarFrame_Button"..displayButton);
			button.effectiveButton = buttonIndex;
		elseif (AutoBar_Config[AutoBar_Player].display.showCategoryIcon and AutoBar_Config[AutoBar_Player].buttons[buttonIndex]) then
			displayButton = displayButton + 1;
			local button = getglobal("AutoBarFrame_Button"..displayButton);
			button.effectiveButton = buttonIndex;
		end
	end
	for buttonIndex = displayButton+1, AUTOBAR_MAXBUTTONS, 1 do
		local button = getglobal("AutoBarFrame_Button"..buttonIndex);
		button.effectiveButton = nil;
	end
	AutoBar_Button_UpdateButtons();
end

local function AutoBar_UpdateCategoryNameToID(name,id)
	local buttonnum, index;
	for buttonnum = 1, AUTOBAR_MAXBUTTONS, 1 do
		if (AutoBar_Config[AutoBar_Player].buttons[buttonnum]) then
			if (type(AutoBar_Config[AutoBar_Player].buttons[buttonnum]) == "table") then
				for index in AutoBar_Config[AutoBar_Player].buttons[buttonnum] do
					if (AutoBar_Config[AutoBar_Player].buttons[buttonnum][index] == name) then
						AutoBar_Config[AutoBar_Player].buttons[buttonnum][index] = id;
						AutoBar_Msg(string.format(AUTOBAR_CHAT_MESSAGE2,buttonnum,idx));
					end
				end
			elseif (AutoBar_Config[AutoBar_Player].buttons[buttonnum] == name) then
				AutoBar_Config[AutoBar_Player].buttons[buttonnum] = id;
				AutoBar_Msg(string.format(AUTOBAR_CHAT_MESSAGE3,buttonnum));
			end
		end
	end
end

function AutoBar_ScanBags(specificbag)
	local function ClearOutBag(bag)
		local buttonnum, index, i, bagSlot, newitemlist, newranks;
		for buttonnum = 1, AUTOBAR_MAXBUTTONS, 1 do
			if (AutoBar_Buttons_CurrentItems[buttonnum]) then 
				newranks = {};
				for index in AutoBar_Buttons_CurrentItems[buttonnum] do
					newitemlist = {};
					for i, bagSlot in AutoBar_Buttons_CurrentItems[buttonnum][index].items do
						if (bag ~= bagSlot[1]) then
							table.insert(newitemlist,bagSlot); 
						end
					end
					if (table.getn(newitemlist) > 0) then
						AutoBar_Buttons_CurrentItems[buttonnum][index].items = newitemlist;
						table.insert(newranks,AutoBar_Buttons_CurrentItems[buttonnum][index]);
					end
				end
				if (table.getn(newranks) == 0) then
					AutoBar_Buttons_CurrentItems[buttonnum] = nil;
				else
					AutoBar_Buttons_CurrentItems[buttonnum] = newranks;
				end
			end
		end
	end
	local function AddItem(buttonnum, rank, bag, slot)
		if (AutoBar_Buttons_CurrentItems[buttonnum]) then 
			local index, rec, findRank;
			for index, rec in AutoBar_Buttons_CurrentItems[buttonnum] do
				if (rec.rank == rank) then
					findRank = index;
				end
			end
			if (findRank) then
				table.insert(AutoBar_Buttons_CurrentItems[buttonnum][findRank].items, { bag, slot } );
			else
				table.insert(AutoBar_Buttons_CurrentItems[buttonnum],
					{
				 		["rank"] = rank,
				 		["items"] = { { bag, slot } }
					}
				);
			end
		else
			AutoBar_Buttons_CurrentItems[buttonnum] = {
				[1] = {
					["rank"] = rank,
					["items"] = { { bag, slot } }
				},
			};
		end
	end
	local function SortByRank(a,b)
		if (a and b and a.rank and b.rank) then
			return a.rank < b.rank;
		else
			return true;
		end
	end

	local bag, slot, name, id, i;
	local minbag,maxbag = 0, 4;
	if (specificbag) then 
		minbag = specificbag; 
		maxbag = specificbag; 
		ClearOutBag(specificbag);
	else
		AutoBar_Buttons_CurrentItems = {};
	end
	-- AutoBar_Buttons_CurrentItems = {
	--	buttonnum = {
	--		index = {
	--			"rank" = ranknum,
	--			"items" = { {bag,slot}, {bag,slot}, {bag, slot} }
	--		},
	--	},
	--};
	for bag = minbag, maxbag, 1 do
		for slot = 1, GetContainerNumSlots(bag), 1 do
			name, id = AutoBar.LinkDecode(GetContainerItemLink(bag,slot));
			if (name and AutoBar_SearchedForItems[name] and id) then
				if (not AutoBar_SearchedForItems[id]) then
					AutoBar_SearchedForItems[id] = { AutoBar_SearchedForItems[name][1], AutoBar_SearchedForItems[name][2], AutoBar_SearchedForItems[name][3] };
				end
				AutoBar_UpdateCategoryNameToID(name,id);
				AutoBar_SearchedForItems[name] = nil;
			end
			if (id and AutoBar_SearchedForItems[id]) then
				local button = AutoBar_SearchedForItems[id][1];
				local rank = AutoBar_ButtonItemList_Reversed[button][id];
				AddItem(button, rank, bag, slot)
				if (AutoBar_SearchedForItems[id][4]) then
					for i = 4, table.getn(AutoBar_SearchedForItems[id]), 1 do
						button = AutoBar_SearchedForItems[id][i];
						rank = AutoBar_ButtonItemList_Reversed[button][id];
						AddItem(button, rank, bag, slot)
					end
				end
			end
		end
	end
	local buttonnum;
	for buttonnum = 1, AUTOBAR_MAXBUTTONS, 1 do
	 	if (AutoBar_Buttons_CurrentItems[buttonnum]) then
			table.sort(AutoBar_Buttons_CurrentItems[buttonnum], SortByRank);
	 	end
	end
	AutoBar_AssignButtons();
end


function AutoBar_OnEvent(event)
	if (event == "PLAYER_ENTERING_WORLD") then
		AutoBar_InCombat = nil;
		if (not AutoBar_ConfigLoaded) then
			AutoBar.ConfigInit();
			AutoBar_ConfigLoaded = 1;
			AutoBar_ScanBags();
		end

		if (not AutoBar.initialized) then

			AutoBarConfig:TabButtonInitialize();

			AutoBar.initialized = true;
		end

		if (not AutoBar_InWorld) then
			AutoBar_InWorld = true;
			AutoBar_ScanBags();
			AutoBar_Button_UpdateButtons();
		end
	elseif (event == "PLAYER_LEAVING_WORLD") then
		AutoBar_InWorld = nil;
	elseif (AutoBar_InWorld) then
		if (event == "BAG_UPDATE") then
			if (arg1 < 5) then
				AutoBar_ScanBags(arg1);
			end
		elseif (event == "UPDATE_BINDINGS") then
			AutoBar_Button_UpdateButtons();
		elseif (event == "PLAYER_ALIVE") then
			AutoBar_Button_UpdateButtons();
		elseif ((event == "UNIT_MANA" or event == "UNIT_HEALTH") and arg1=="player") then
			AutoBar_Button_UpdateButtons();
		elseif (event == "PLAYER_REGEN_ENABLED") then
			AutoBar_InCombat = nil;
			AutoBar_Button_UpdateButtons();
		elseif (event == "PLAYER_REGEN_DISABLED") then
			AutoBar_InCombat = 1;
			AutoBar_Button_UpdateButtons();
		elseif (event == "ZONE_CHANGED_NEW_AREA") then
			AutoBar_Button_UpdateButtons();
		elseif (event == "BAG_UPDATE_COOLDOWN") then
			AutoBar_Button_UpdateButtons();
		elseif (event == "UPDATE_BATTLEFIELD_STATUS") then
			for i=1, MAX_BATTLEFIELD_QUEUES do
				local status, mapName, instanceID = GetBattlefieldStatus(i);
				if (instanceID ~= 0) then
					Autobar_InBG = 1;
					return;
				else
					Autobar_InBG = nil;
				end
			end
		end
	end
end


function AutoBar:SlotUse(slotIndex)
	AutoBar_Button_OnClick("LeftButton", "CLICK", slotIndex);
end


function AutoBar_Button_OnClick(mousebutton, updown, override)
	local button, effectiveButton;
	if (override) then
		button = getglobal("AutoBarFrame_Button"..override);
		effectiveButton = override;
	else
		button = this;
		effectiveButton = button.effectiveButton;
	end
	button:SetChecked(0);
	if (AutoBarFrame.moving) then
		if (updown == "CLICK") then
			AutoBarFrame.moving = nil;
			AutoBarFrame:StopMovingOrSizing();
			AutoBar_Config[AutoBar_Player].display.position = {};
			AutoBar_Config[AutoBar_Player].display.position.x,
			AutoBar_Config[AutoBar_Player].display.position.y = AutoBarFrame:GetCenter();
		end
	elseif (updown == "CLICK") then
		local bag, slot, rank, itemId, category, categoryIndex, index, acceptable = AutoBar_Button_GetDisplayItem(effectiveButton);
		if (bag and slot) then
			local buttonInfo = AutoBar_Config[AutoBar_Player].buttons[effectiveButton];

			if (mousebutton == "RightButton" and type(buttonInfo) == "table" and buttonInfo.rightClickTargetsPet and UnitExists("pet")) then
				PickupContainerItem(bag, slot);
				DropItemOnUnit("pet");
			else
				UseContainerItem(bag, slot);
			end

			if (AutoBar_Category_Info[category] and AutoBar_Category_Info[category].targetted == "WEAPON" and SpellIsTargeting()) then
				if (mousebutton == "LeftButton") then
					PickupInventoryItem(GetInventorySlotInfo("MainHandSlot"));
				elseif (mousebutton == "RightButton") then
					PickupInventoryItem(GetInventorySlotInfo("SecondaryHandSlot"));
				end
			elseif (AutoBar_Category_Info[category] and AutoBar_Category_Info[category].targetted and (AutoBar_Config[AutoBar_Player].autoSmartSelfCast or AutoBar_Config[AutoBar_Player].smartselfcast and AutoBar_Config[AutoBar_Player].smartselfcast[category]) and SpellIsTargeting()) then
				SpellTargetUnit("player");
			elseif (type(AutoBar_Config[AutoBar_Player].buttons[effectiveButton]) == "table" and AutoBar_Config[AutoBar_Player].buttons[effectiveButton].rightClickTargetsPet and SpellIsTargeting()) then
				SpellTargetUnit("pet");
			end
			AutoBarPopupFrame:Hide();
			AutoBar.SetPopupButton(button);
		end
	elseif (mousebutton == "RightButton" and updown == "DOWN" and IsControlKeyDown()) then
		if (not AutoBar_Config[AutoBar_Player].display.docking) then
			AutoBarFrame.moving = true;
			AutoBarFrame:StartMoving();
		end
	end
end


-- Add tooltip info about the other categories in a slot to the current GameTooltip
function AutoBar_ButtonSetTooltipCategories(currentItems, categoryIndex)
	local count = 0;
	local itemCount;
	for index, bagSlot in currentItems.items do
		_, itemCount = GetContainerItemInfo(bagSlot[1], bagSlot[2]);
		if (not itemCount) then
		    itemCount = 0;
		end
		count = count + itemCount;
	end
	local name, itemId = AutoBar.LinkDecode(GetContainerItemLink(currentItems.items[1][1], currentItems.items[1][2]));
	local category = AutoBar_SearchedForItems[itemId][2];
	local start, duration, enable = GetContainerItemCooldown(currentItems.items[1][1], currentItems.items[1][2]);
	local msg = name..AUTOBAR_TOOLTIP1..count..")";
	if (AutoBar_Debug) then
		msg = msg.." ["..currentItems.items[1][1]..","..currentItems.items[1][2].."]";
		if (rank) then
			msg = msg.." rank="..currentItems.rank;
		end
		if (cat) then
			msg = msg.." cat="..category;
		end
	end
	if (category == itemId and categoryIndex == 0) then
		msg = msg..AUTOBAR_TOOLTIP2
	end
	if (AutoBar_Category_Info[category]) then
		if (AutoBar_Category_Info[category].combatonly) then
			msg=msg..AUTOBAR_TOOLTIP3;
		end
		if (AutoBar_Category_Info[category].battleground) then
			msg=msg..AUTOBAR_TOOLTIP4;
		end
		if (AutoBar_Category_Info[category].noncombat) then
			msg=msg..AUTOBAR_TOOLTIP5;
		end
		if (AutoBar_Category_Info[category].limit) then
			msg=msg..AUTOBAR_TOOLTIP6;
		end
	end
	if (start > 0 and duration > 0) then
		msg = msg..AUTOBAR_TOOLTIP7;
	end
	GameTooltip:AddLine(msg);
	if (category and AutoBar_Category_Info[category] and AutoBar_Category_Info[category].targetted == "WEAPON") then
		GameTooltip:AddLine(AUTOBAR_TOOLTIP8);
	end
end


-- Set the tooltip for an AutoBarFrame or AutoBarPopupFrame button
function AutoBar.ButtonSetTooltip(button, elapsed)
	if (AutoBar_Config[AutoBar_Player].display.hideTooltips) then
		return;
	end
	if (not button) then
		button = this;
	end
	if (button:GetParent().updateTooltip and elapsed) then
		button.updateTooltip = button.updateTooltip - elapsed;
		if (button.updateTooltip > 0) then return; end
	end

	-- AutoBarFrame Button has effectiveButton, AutoBarPopupFrame Button has bagSlot
	local effectiveButton;
	if (button.effectiveButton or button.bagSlot) then
		if (GetCVar("UberTooltips") == "1") then
			GameTooltip_SetDefaultAnchor(GameTooltip, button);
		else
			GameTooltip:SetOwner(button, "ANCHOR_RIGHT");
		end
		button.updateTooltip = nil;

		local bag, slot, rank, itemId, category, categoryIndex;
		if (button.bagSlot) then
		    bag = button.bagSlot[1];
		    slot = button.bagSlot[2];
		    category = button.category;
		    effectiveButton = button:GetParent().popupButton;
		elseif (button.effectiveButton) then
		    effectiveButton = button.effectiveButton;
			bag, slot, rank, itemId, category, categoryIndex = AutoBar_Button_GetDisplayItem(button.effectiveButton)
		else
		    return;
		end
		if (bag and slot) then
			GameTooltip:SetBagItem(bag, slot);
			if (AutoBar_Debug) then
				if (rank) then
					GameTooltip:AddLine("DISPLAYED RANK: "..rank);
				end
				if (itemId) then
					GameTooltip:AddLine("DISPLAYED ITEMID: "..itemId);
				end
				if (category) then
					GameTooltip:AddLine("DISPLAYED CATEGORY: "..category);
				end
				if (categoryIndex) then
					GameTooltip:AddLine("DISPLAYED CATEGORY INDEX: "..categoryIndex);
				end
			end

			local start, duration, enable = GetContainerItemCooldown(bag, slot);
			if (start > 0 and duration > 0) then
				button.updateTooltip = TOOLTIP_UPDATE_TIME;
			end
	
			GameTooltip:AddLine("");
			local rankIndex, index, currentItems, bagSlot, count, itemCount, name, itemId, msg;
			for rankIndex, currentItems in AutoBar_Buttons_CurrentItems[effectiveButton] do
			    -- Display all possible items for AutoBarFrame or just the specific item for AutoBarPopupFrame
			    if (button.effectiveButton or button.popupButtonIndex == rankIndex) then
					AutoBar_ButtonSetTooltipCategories(currentItems, categoryIndex);
				end
			end
			GameTooltip:Show();
		end
	else
--DEFAULT_CHAT_FRAME:AddMessage("AutoBar.ButtonSetTooltip unhandled button ", 1, 0.5, 0);
	end
end


-- Return the display texture of the object
function AutoBar_GetTexture(id)
	if (not id) then
		return "";
	end
	
	-- Last item has priority so use its icon
	if (type(id) == "table" and id[1]) then
	    id = id[table.getn(id)];
	end

	if (id and AutoBar_Category_Info[id]) then
		if (AutoBar_Category_Info[id].texture) then
			return "Interface\\Icons\\"..AutoBar_Category_Info[id].texture;
		else
			id = AutoBar_Category_Info[id].items[table.getn(AutoBar_Category_Info[id].items)];
		end
	end
	if (type(id)=="number" and id > 0) then
		local _,_,_,_,_,_,_,_,texture = GetItemInfo(tonumber(id));
		if (texture) then return texture; end
	end
	return "Interface\\Icons\\INV_Misc_Gift_01";
end


function AutoBar_Msg(...)
	local message = "";
	for i = 1, arg.n, 1 do
		if (type(arg[i]) == "string" or type(arg[i]) == "number") then
			message = message..arg[i];
		else
			message = message..string.upper(type(arg[i]));
		end
	end
	ChatFrame1:AddMessage(AUTOBAR_CHAT_MESSAGE4..message);
end


function AutoBar.ConfigUpdated()
	AutoBar_BuildItemList();
	AutoBar_ScanBags();
	AutoBar_SetupVisual();
end


AutoBar.UpdateTalentButton = UpdateTalentButton;

function AutoBar_SetupVisual()
	if (not AutoBar_Config[AutoBar_Player].display.rows) then
		AutoBar_Config[AutoBar_Player].display.rows = AutoBarConfigSliders.rows.default;
	end
	if (not AutoBar_Config[AutoBar_Player].display.columns) then
		AutoBar_Config[AutoBar_Player].display.columns = AutoBarConfigSliders.columns.default;
	end
	if (not AutoBar_Config[AutoBar_Player].display.gapping) then
		AutoBar_Config[AutoBar_Player].display.gapping = AutoBarConfigSliders["gapping"]["default"];
	end
	if (not AutoBar_Config[AutoBar_Player].display.alpha) then
		AutoBar_Config[AutoBar_Player].display.alpha = AutoBarConfigSliders["alpha"]["default"];
	end
	if (not AutoBar_Config[AutoBar_Player].display.buttonWidth) then
		AutoBar_Config[AutoBar_Player].display.buttonWidth = AutoBarConfigSliders["buttonWidth"]["default"];
	end
	if (not AutoBar_Config[AutoBar_Player].display.buttonHeight) then
		AutoBar_Config[AutoBar_Player].display.buttonHeight = AutoBarConfigSliders["buttonHeight"]["default"];
	end
	if (not AutoBar_Config[AutoBar_Player].display.dockShiftX) then
		AutoBar_Config[AutoBar_Player].display.dockShiftX = AutoBarConfigSliders["dockShiftX"]["default"];
	end
	if (not AutoBar_Config[AutoBar_Player].display.dockShiftY) then
		AutoBar_Config[AutoBar_Player].display.dockShiftY = AutoBarConfigSliders["dockShiftY"]["default"];
	end
	if (not AutoBar_Config[AutoBar_Player].display.popupToTop and AutoBar_Config[AutoBar_Player].display.popupToLeft and
			AutoBar_Config[AutoBar_Player].display.popupToRight and AutoBar_Config[AutoBar_Player].display.popupToBottom) then
		AutoBar_Config[AutoBar_Player].display.popupToTop = true;
	end

	local rows = AutoBar_Config[AutoBar_Player].display.rows;
	local columns = AutoBar_Config[AutoBar_Player].display.columns;
	local gapping = AutoBar_Config[AutoBar_Player].display.gapping;
	local dockShiftX = AutoBar_Config[AutoBar_Player].display.dockShiftX;
	local dockShiftY = AutoBar_Config[AutoBar_Player].display.dockShiftY;

	AutoBarFrame:Show();
	AutoBarFrame:EnableMouse(true);
	AutoBarFrame:ClearAllPoints();

--	if (AutoBar_Config[AutoBar_Player].display.docking == "MAINMENU") then
--		AutoBarFrame:SetFrameStrata("HIGH");
--		AutoBar.UpdateTalentButton = UpdateTalentButton;
--		UpdateTalentButton = function() return; end
--		CharacterMicroButton:Hide();
--		SpellbookMicroButton:Hide();
--		TalentMicroButton:Hide();
--		QuestLogMicroButton:Hide();
--		SocialsMicroButton:Hide();
--		WorldMapMicroButton:Hide();
--		MainMenuMicroButton:Hide();
--		HelpMicroButton:Hide();
--	else
--		AutoBarFrame:SetFrameStrata("LOW");
--		UpdateTalentButton = AutoBar.UpdateTalentButton;
--		CharacterMicroButton:Show();
--		SpellbookMicroButton:Show();
--		TalentMicroButton:Show();
--		QuestLogMicroButton:Show();
--		SocialsMicroButton:Show();
--		WorldMapMicroButton:Show();
--		MainMenuMicroButton:Show();
--		HelpMicroButton:Show();
--	end

	local i, normalTexture, countText, hotKey, fonttext, fontsize, fontoptions, cooldown;
	for i = 1, AUTOBAR_MAXBUTTONS, 1 do
		local button = getglobal("AutoBarFrame_Button"..i);
		if (i > (rows * columns)) then
			button:Hide();
			button.forcehidden = 1;
		else
			AutoBar:ButtonSetup("AutoBarFrame_Button"..i);

			-- Set the relative positions of the buttons
			button:ClearAllPoints();
			if (i == 1) then
				button:SetPoint("TOPLEFT", "AutoBarFrame", "TOPLEFT", 0, 0);
			elseif (columns == 1) then
				if (AutoBar_Config[AutoBar_Player].display.reverseButtons) then
					button:SetPoint("BOTTOM", "AutoBarFrame_Button"..(i-1), "TOP", 0, gapping);
				else
					button:SetPoint("TOP", "AutoBarFrame_Button"..(i-1), "BOTTOM", 0, gapping * -1);
				end
			elseif (math.mod(i, columns) == 1) then
				local row = math.floor(i / columns);
				if (AutoBar_Config[AutoBar_Player].display.reverseButtons) then
					button:SetPoint("BOTTOM", "AutoBarFrame_Button"..(i-columns), "TOP", 0, gapping);
				else
					button:SetPoint("TOP", "AutoBarFrame_Button"..(i-columns), "BOTTOM", 0, gapping*-1);
				end
			else
				if (AutoBar_Config[AutoBar_Player].display.reverseButtons) then
					button:SetPoint("RIGHT", "AutoBarFrame_Button"..(i-1), "LEFT", gapping * -1,0);
				else
					button:SetPoint("LEFT", "AutoBarFrame_Button"..(i-1), "RIGHT", gapping, 0);
				end
			end
		end
	end
	AutoBar_AssignButtons();
	AutoBar_Button_UpdateButtons();
	if (AutoBar_Config[AutoBar_Player].display.hideDragHandle) then
	    AutoBar:HideHandle(AutoBarFrame);
	else
	    AutoBar:ShowHandle(AutoBarFrame);
	end
	getglobal("AutoBarFrameHandle"):SetChecked(AutoBar_Config[AutoBar_Player].display.frameLocked);

	local frameWidth = (AutoBar_Config[AutoBar_Player].display.buttonWidth + gapping) + 1;
	local frameHeight = (AutoBar_Config[AutoBar_Player].display.buttonHeight + gapping) + 1;
	AutoBarFrame:SetWidth(frameWidth);
	AutoBarFrame:SetHeight(frameHeight);
	if (AutoBar_Config[AutoBar_Player].display.docking == "MAINMENU") then
		AutoBarFrame:SetPoint("BOTTOMLEFT", "MainMenuBarArtFrame", "BOTTOMLEFT", 546 + dockShiftX, 38 + dockShiftY);
	elseif (AutoBar_Config[AutoBar_Player].display.docking and getglobal(AutoBar_Config[AutoBar_Player].display.docking)) then
		AutoBarFrame:SetPoint("BOTTOMLEFT", AutoBar_Config[AutoBar_Player].display.docking, "TOPLEFT", dockShiftX, dockShiftY);
	elseif (AutoBar_Config[AutoBar_Player].display.position) then
		AutoBarFrame:SetPoint("CENTER", "UIParent", "BOTTOMLEFT",
		AutoBar_Config[AutoBar_Player].display.position.x,
		AutoBar_Config[AutoBar_Player].display.position.y);
	else
		AutoBarFrame:SetPoint("CENTER","UIParent","CENTER",0,0);
	end
end


-- Set the visual look and feel for the button
function AutoBar:ButtonSetup(buttonName)
	local button = getglobal(buttonName);
	local buttonWidth = AutoBar_Config[AutoBar_Player].display.buttonWidth;
	local buttonHeight = AutoBar_Config[AutoBar_Player].display.buttonHeight;
	local fontScale = buttonWidth / 36;
	local alpha = AutoBar_Config[AutoBar_Player].display.alpha / 10;
	
	local normalTexture = getglobal(buttonName.."NormalTexture");
	local countText = getglobal(buttonName.."Count");
	local hotKey = getglobal(buttonName.."HotKey");
	local cooldown = getglobal(buttonName.."Cooldown");
	local icon = getglobal(buttonName.."Icon");

	button.forcehidden = nil;
	button:SetAlpha(alpha);
	normalTexture:SetAlpha(alpha);
	button:SetWidth(buttonWidth);
	button:SetHeight(buttonHeight);

	if (AutoBar_Config[AutoBar_Player].display.plainButtons) then
		button:SetNormalTexture("");
		icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
	else
		button:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
		icon:SetTexCoord(0,1,0,1)
		normalTexture:SetWidth(buttonWidth * 1.833);  -- Mmm what is this magical scaling factor?
		normalTexture:SetHeight(buttonHeight * 1.833);
	end

	local fonttext, fontsize, fontoptions;
	if (AutoBar_Config[AutoBar_Player].display.hideKeyText) then
		hotKey:Hide();
	else
		fonttext, fontsize, fontoptions = hotKey:GetFont();
		hotKey:SetFont(fonttext, 12 * fontScale, fontoptions);
		hotKey:SetJustifyH("LEFT");
		hotKey:SetJustifyV("TOP");
		hotKey:SetPoint("TOPLEFT", buttonName, "TOPLEFT", 2, -2);
		hotKey:Show();
	end
	if (AutoBar_Config[AutoBar_Player].display.hideCount) then
		countText:Hide();
	else
		countText:Show();
		fonttext, fontsize, fontoptions = countText:GetFont();
		countText:SetFont(fonttext, 14 * fontScale, fontoptions);
	end

	cooldown:SetScale(math.max(buttonWidth-1, buttonHeight-1) / 36);
end


--
-- Popup Buttons
--

-- If eligible set the slot for which to do the popup for.  Only pop up for 2 or more items.
function AutoBar.SetPopupButton(button)
	if (not button) then
		button = this;
	end

	if (AutoBar_Config[AutoBar_Player].display.popupDisable) then
		return;
	end
	
	if (button.effectiveButton) then
		local buttonInfo = AutoBar_Config[AutoBar_Player].buttons[button.effectiveButton];
		if (type(buttonInfo) ~= "table") then
			AutoBarPopupFrame:Hide();
			return;
		end
		if (buttonInfo.noPopup) then
			return;
		elseif (AutoBar_Config[AutoBar_Player].display.popupOnShift) then
			AutoBar.StartTimer("PopupShiftkey", 0.2)
			if (not IsShiftKeyDown()) then
				return;
			end
		end
		if (not AutoBar_Buttons_CurrentItems[button.effectiveButton] or type(AutoBar_Buttons_CurrentItems[button.effectiveButton]) ~= "table" or table.getn(AutoBar_Buttons_CurrentItems[button.effectiveButton]) <= 1) then
			AutoBarPopupFrame:Hide();
			return;
		end

		AutoBarPopupFrame.popupButton = button.effectiveButton;
		AutoBar.UpdatePopupButtons(button);
		AutoBarPopupFrame:Show();
		AutoBarPopupFrame:EnableMouse(true);
	end
end


-- Populate the popup list for the popupButton and display relative to baseButton
function AutoBar.UpdatePopupButtons(baseButton)
	local popupButtonIndex, button, hotKey, icon, countText, normalTexture, cooldown;
	local autoBarPopup = getglobal("AutoBarPopupFrame");
	local gapping = AutoBar_Config[AutoBar_Player].display.gapping;
	local buttonWidth = AutoBar_Config[AutoBar_Player].display.buttonWidth;
	local buttonHeight = AutoBar_Config[AutoBar_Player].display.buttonHeight;
	local hitRectOutside = -1 * math.ceil(math.max(buttonWidth, buttonHeight, 40, gapping) / 2);
	local hitRectInside = -1 * math.ceil(gapping / 2);

	for popupButtonIndex = 1, AUTOBAR_MAXPOPUPBUTTONS, 1 do
		button = getglobal("AutoBarPopupFrame_Button"..popupButtonIndex);
		button:Hide();
	end

	local currentItems, index, bagSlot, count, itemCount, name, itemId;
	local start, duration, enable;
	local _, _, _, baseItemId, _, _ = AutoBar_Button_GetDisplayItem(AutoBarPopupFrame.popupButton);
	local effectiveLocation = 1;
	
	for popupButtonIndex, currentItems in AutoBar_Buttons_CurrentItems[AutoBarPopupFrame.popupButton] do
		if (popupButtonIndex > AUTOBAR_MAXPOPUPBUTTONS) then
			break;
		end
		name, itemId = AutoBar.LinkDecode(GetContainerItemLink(currentItems.items[1][1], currentItems.items[1][2]));
		category = AutoBar_SearchedForItems[itemId][2];
		button = getglobal("AutoBarPopupFrame_Button"..popupButtonIndex);
		hotKey = getglobal("AutoBarPopupFrame_Button"..popupButtonIndex.."HotKey");
		icon = getglobal("AutoBarPopupFrame_Button"..popupButtonIndex.."Icon");
		countText = getglobal("AutoBarPopupFrame_Button"..popupButtonIndex.."Count");
		normalTexture = getglobal("AutoBarPopupFrame_Button"..popupButtonIndex.."NormalTexture");
		cooldown = getglobal("AutoBarPopupFrame_Button"..popupButtonIndex.."Cooldown");
		button.popupButtonIndex = popupButtonIndex;

		count = 0;
		for index, bagSlot in currentItems.items do
			_, itemCount = GetContainerItemInfo(bagSlot[1], bagSlot[2]);
			count = count + itemCount;
		end

		button:Show();
		button:SetWidth(buttonWidth);
		button:SetHeight(buttonHeight);
		hotKey:SetText("");

		if (count > 0) then
			icon:SetTexture(GetContainerItemInfo(currentItems.items[1][1], currentItems.items[1][2]));
			countText:SetText(count);
			button.bagSlot = currentItems.items[1];
			button.category = category;
		else
			if (category and AutoBar_Category_Info[category] and AutoBar_Category_Info[category].texture) then
				icon:SetTexture(AutoBar_Category_Info[category].texture);
			else
				icon:SetTexture("");
			end
			countText:SetText("--");
			button.bagSlot = nil;
			button.category = nil;
		end

		start, duration, enable = GetContainerItemCooldown(currentItems.items[1][1], currentItems.items[1][2]);
		CooldownFrame_SetTimer(cooldown, start, duration, enable);
		if (enable and count > 0) then
			icon:SetVertexColor(1, 1, 1);
			normalTexture:SetVertexColor(1, 1, 1);
		elseif (start > 0 and duration > 0) then
			icon:SetVertexColor(1, 1, 1);
			normalTexture:SetVertexColor(1, 1, 1);
		else
			icon:SetVertexColor(0.4, 0.4, 0.4);
			normalTexture:SetVertexColor(1, 1, 1);
		end

	    AutoBar:ButtonSetup("AutoBarPopupFrame_Button"..popupButtonIndex);

		-- Set the relative positions of the buttons
	    button:ClearAllPoints();
		-- For the popup expand the mouse hit area of the buttons so selection is easier
		if (effectiveLocation == 1) then
			if (AutoBar_Config[AutoBar_Player].display.popupToBottom) then
				button:SetHitRectInsets(hitRectOutside, hitRectOutside, -1 * gapping, hitRectInside);
				button:SetPoint("TOP", baseButton, "BOTTOM", 0, -1 * gapping);
			elseif (AutoBar_Config[AutoBar_Player].display.popupToLeft) then
				button:SetHitRectInsets(hitRectInside, -1 * gapping, hitRectOutside, hitRectOutside);
				button:SetPoint("RIGHT", baseButton, "LEFT", -1 * gapping, 0);
			elseif (AutoBar_Config[AutoBar_Player].display.popupToRight) then
				button:SetHitRectInsets(-1 * gapping, hitRectInside, hitRectOutside, hitRectOutside);
				button:SetPoint("LEFT", baseButton, "RIGHT", gapping, 0);
			else
				button:SetHitRectInsets(hitRectOutside, hitRectOutside, hitRectInside, -1 * gapping);
				button:SetPoint("BOTTOM", baseButton, "TOP", 0, gapping);
			end
		else
			if (AutoBar_Config[AutoBar_Player].display.popupToBottom) then
				button:SetHitRectInsets(hitRectOutside, hitRectOutside, hitRectInside, hitRectInside);
				button:SetPoint("TOP", "AutoBarPopupFrame_Button"..(effectiveLocation-1), "BOTTOM", 0, -1 * gapping);
			elseif (AutoBar_Config[AutoBar_Player].display.popupToLeft) then
				button:SetHitRectInsets(hitRectInside, hitRectInside, hitRectOutside, hitRectOutside);
				button:SetPoint("RIGHT", "AutoBarPopupFrame_Button"..(effectiveLocation-1), "LEFT", -1 * gapping, 0);
			elseif (AutoBar_Config[AutoBar_Player].display.popupToRight) then
				button:SetHitRectInsets(hitRectInside, hitRectInside, hitRectOutside, hitRectOutside);
				button:SetPoint("LEFT", "AutoBarPopupFrame_Button"..(effectiveLocation-1), "RIGHT", gapping, 0);
			else
				button:SetHitRectInsets(hitRectOutside, hitRectOutside, hitRectInside, hitRectInside);
				button:SetPoint("BOTTOM", "AutoBarPopupFrame_Button"..(effectiveLocation-1), "TOP", 0, gapping);
			end
		end
	    if (baseItemId == itemId) then
--DEFAULT_CHAT_FRAME:AddMessage("AutoBar.UpdatePopupButtons baseItemId == itemId " .. baseItemId .. " " .. itemId, 1, 0.5, 0);
			button:Hide();
		else
		    effectiveLocation = effectiveLocation + 1;
	    end
	end

	AutoBarPopupFrame:Show();
	AutoBar.StartTimer("PopupMouseover", 1)
end                                                                       


-- Handle a click on a popped up button
function AutoBar.PopupButtonOnClick(mousebutton)
	local button = this;
	button:SetChecked(0);
	if (button.bagSlot) then
		if (button.bagSlot[1] and button.bagSlot[2]) then
			local buttonInfo = AutoBar_Config[AutoBar_Player].buttons[AutoBarPopupFrame.popupButton];

			if (mousebutton == "RightButton" and type(buttonInfo) == "table" and buttonInfo.rightClickTargetsPet and UnitExists("pet")) then
				PickupContainerItem(button.bagSlot[1], button.bagSlot[2]);
				DropItemOnUnit("pet");
			else
				UseContainerItem(button.bagSlot[1], button.bagSlot[2]);
			end
			if (AutoBar_Category_Info[button.category] and AutoBar_Category_Info[button.category].targetted == "WEAPON" and SpellIsTargeting()) then
				if (mousebutton == "LeftButton") then
					PickupInventoryItem(GetInventorySlotInfo("MainHandSlot"));
				elseif (mousebutton == "RightButton") then
					PickupInventoryItem(GetInventorySlotInfo("SecondaryHandSlot"));
				end
			elseif (AutoBar_Category_Info[button.category] and AutoBar_Category_Info[button.category].targetted and (AutoBar_Config[AutoBar_Player].autoSmartSelfCast or AutoBar_Config[AutoBar_Player].smartselfcast and AutoBar_Config[AutoBar_Player].smartselfcast[category]) and SpellIsTargeting()) then
				SpellTargetUnit("player");
			end

			if (type(buttonInfo) == "table") then
				if (buttonInfo.arrangeOnUse) then
					local index;
					local currentItems = AutoBar_Buttons_CurrentItems[AutoBarPopupFrame.popupButton][button.popupButtonIndex];
					local _, itemId = AutoBar.LinkDecode(GetContainerItemLink(currentItems.items[1][1], currentItems.items[1][2]));
					local category = AutoBar_SearchedForItems[itemId][2];
					for index = 1, AUTOBAR_MAXSLOTCATEGORIES, 1 do
						if (buttonInfo[index] == category) then
							local targetIndex = table.getn(buttonInfo);
							local temp = buttonInfo[index];
							buttonInfo[index] = buttonInfo[targetIndex];
							buttonInfo[targetIndex] = temp;
							AutoBar.ConfigUpdated();
							break;
						end	
					end
				end
			end
		end
		AutoBarPopupFrame:Hide();
	end
end


-- Timer callback to detect mouse focus leaving
function AutoBar.PopupMouseover()
   	local gapping = AutoBar_Config[AutoBar_Player].display.gapping;

    if (GetMouseFocus() and GetMouseFocus():GetParent() ~= AutoBarFrame and GetMouseFocus():GetParent() ~= AutoBarPopupFrame) then
		AutoBar.StopTimer("PopupMouseover");
		AutoBarPopupFrame:Hide();
	end
end


-- Timer callback to detect shift key over bar
function AutoBar.PopupShiftkey()
	if (AutoBar_Config[AutoBar_Player].display.popupOnShift) then
		if (IsShiftKeyDown()) then
			if (GetMouseFocus() and GetMouseFocus():GetParent() == AutoBarFrame) then
				AutoBar.SetPopupButton(GetMouseFocus());
			elseif (GetMouseFocus() and GetMouseFocus():GetParent() == AutoBarPopupFrame) then
				return;
			else
				AutoBarPopupFrame:Hide();
				AutoBar.StopTimer("PopupShiftkey");
				return;
			end
		else
			AutoBarPopupFrame:Hide();
			if (GetMouseFocus() and GetMouseFocus():GetParent() ~= AutoBarFrame and GetMouseFocus():GetParent() ~= AutoBarPopupFrame) then
				AutoBar.StopTimer("PopupShiftkey");
			end
		end
	else
		AutoBarPopupFrame:Hide();
		AutoBar.StopTimer("PopupShiftkey");
	end
end


--
-- Timers.  (Sourced from TrinketMenu, cleaned up & some bug fixes)
--

function AutoBar.InitTimers()
	AutoBar.TimerPool = {};
	AutoBar.Timers = {};
end


-- Create a named timer.
function AutoBar.CreateTimer(name, callbackFunction, delay, oneShot)
	AutoBar.TimerPool[name] = { callbackFunction = callbackFunction, delay = delay, elapsed = delay, oneShot = oneShot };
end


-- Return true if the timer is active
function AutoBar.IsTimerActive(name)
	for i, j in ipairs(AutoBar.Timers) do
		if (j == name) then
			return i;
		end
	end
	return nil;
end


-- Start a timer.  Does not need matched Start & Stop calls
-- delay is optional if default needs overriding
function AutoBar.StartTimer(name, delay)
	AutoBar.TimerPool[name].elapsed = delay or AutoBar.TimerPool[name].delay
	if not (AutoBar.IsTimerActive(name)) then
		table.insert(AutoBar.Timers, name);
		AutoBarTimersFrame:Show();
	end
end


-- Stop a timer.  Does not need matched Start & Stop calls
function AutoBar.StopTimer(name)
	local idx = AutoBar.IsTimerActive(name)
	if (idx) then
		table.remove(AutoBar.Timers, idx);
		if (table.getn(AutoBar.Timers) < 1) then
			AutoBarTimersFrame:Hide();
		end
	end
end


-- Update callback for timers
function AutoBar.TimersFrame_OnUpdate()
	local timerPool
	for _, name in ipairs(AutoBar.Timers) do
		timerPool = AutoBar.TimerPool[name];
		if (timerPool) then
			timerPool.elapsed = timerPool.elapsed - arg1;
			if timerPool.elapsed < 0 then
				timerPool.callbackFunction();
				if (timerPool.oneShot) then
					AutoBar.StopTimer(name);
				else
					timerPool.elapsed = timerPool.delay;
				end
			end
		end
	end
end


function AutoBar.TimerDebug()
	local on = "|cFF00FF00On";
	local off = "|cFFFF0000Off";
	DEFAULT_CHAT_FRAME:AddMessage("|cFF44AAFFAutoBarTimersFrame is "..(AutoBarTimersFrame:IsVisible() and on or off));
	for i in AutoBar.TimerPool do
		DEFAULT_CHAT_FRAME:AddMessage(i.." is "..(AutoBar.IsTimerActive(i) and on or off));
	end
end


--
-- Drag Handle.  (Sourced from GBars)
--

-- Lock the frame so it is unmovable
function AutoBar:ClickHandle(button)
	local frame = this:GetParent();
	if (button == "RightButton") then
		AutoBarConfig_Toggle();
		this:SetChecked(AutoBar_Config[AutoBar_Player].display.frameLocked);
	elseif (button == "LeftButton") then
		AutoBar_Config[AutoBar_Player].display.frameLocked = not AutoBar_Config[AutoBar_Player].display.frameLocked;
		this:SetChecked(AutoBar_Config[AutoBar_Player].display.frameLocked);                        
	end
end


function AutoBar:Lock(frame)
	if (not frame) then frame = this; end
	if (AutoBar_Config[AutoBar_Player].display.frameLocked) then return end
	AutoBar:HideHandle(frame)
	AutoBar_Config[AutoBar_Player].display.frameLocked = true;
end


-- Unlock the frame so it is movable
function AutoBar:Unlock(frame)
	if (not frame) then frame = this; end
	if (not AutoBar_Config[AutoBar_Player].display.frameLocked) then return end
	AutoBar:ShowHandle(frame)
	AutoBar_Config[AutoBar_Player].display.frameLocked = false;
end


-- If the passed-in frame has a handle, show it
function AutoBar:ShowHandle(frame)
	local handle = getglobal(frame:GetName().."Handle")
	if (handle) then
		handle:SetScale(0.6)
		handle:Show();
	end
end


-- If the passed-in frame has a handle, hide it
function AutoBar:HideHandle(frame)
	local handle = getglobal(frame:GetName().."Handle")
	if (handle) then
		handle:Hide()
	end
end


-- Start dragging if not locked
function AutoBar:DragStart(frame)
--DEFAULT_CHAT_FRAME:AddMessage("AutoBar:DragStart" .. this:GetName(), 1, 0.5, 0);
	if (not frame) then frame = this:GetParent(); end
	if (not AutoBar_Config[AutoBar_Player].display.frameLocked) then
		frame.isMoving = true;
		frame:StartMoving();
	end
end


-- End dragging
function AutoBar:DragStop(frame)
--DEFAULT_CHAT_FRAME:AddMessage("AutoBar:DragStop", 1, 0.5, 0);
	if (not frame) then frame = this:GetParent(); end
	frame:StopMovingOrSizing()
	AutoBar_Config[AutoBar_Player].display.position = {};
	AutoBar_Config[AutoBar_Player].display.position.x,
	AutoBar_Config[AutoBar_Player].display.position.y = AutoBarFrame:GetCenter();
	frame.isMoving = nil;
	AutoBar_Config[AutoBar_Player].display.docking = nil;
end


function AutoBar.OnLoad()
	AutoBar_Player = UnitName("player").." - "..GetCVar("realmName");

	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_LEAVING_WORLD");
	--
	this:RegisterEvent("BAG_UPDATE");
	this:RegisterEvent("UPDATE_BINDINGS");
	--
	-- For item use restrictions
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("PLAYER_ALIVE");
	this:RegisterEvent("BAG_UPDATE_COOLDOWN");
	this:RegisterEvent("UPDATE_BATTLEFIELD_STATUS");
	--
	AutoBar.InitTimers()
	AutoBar.CreateTimer("PopupMouseover", AutoBar.PopupMouseover, .25, false)
	AutoBar.CreateTimer("PopupShiftkey", AutoBar.PopupShiftkey, .25, false)
end


